<?php

	/**
	 * Original data taken from:
	 * ftp://ftp.unicode.org/Public/MAPPINGS/VENDORS/MICSFT/WINDOWS/CP1256.TXT
	 * @param string $string
	 * @return string
	 */
	function charset_decode_windows_1256($string)
	{
		$mapping = array(
					"\x80" => "\xE2\x82\xAC",
					"\x81" => "\xD9\xBE",
					"\x82" => "\xE2\x80\x9A",
					"\x83" => "\xC6\x92",
					"\x84" => "\xE2\x80\x9E",
					"\x85" => "\xE2\x80\xA6",
					"\x86" => "\xE2\x80\xA0",
					"\x87" => "\xE2\x80\xA1",
					"\x88" => "\xCB\x86",
					"\x89" => "\xE2\x80\xB0",
					"\x8A" => "\xD9\xB9",
					"\x8B" => "\xE2\x80\xB9",
					"\x8C" => "\xC5\x92",
					"\x8D" => "\xDA\x86",
					"\x8E" => "\xDA\x98",
					"\x8F" => "\xDA\x88",
					"\x90" => "\xDA\xAF",
					"\x91" => "\xE2\x80\x98",
					"\x92" => "\xE2\x80\x99",
					"\x93" => "\xE2\x80\x9C",
					"\x94" => "\xE2\x80\x9D",
					"\x95" => "\xE2\x80\xA2",
					"\x96" => "\xE2\x80\x93",
					"\x97" => "\xE2\x80\x94",
					"\x98" => "\xDA\xA9",
					"\x99" => "\xE2\x84\xA2",
					"\x9A" => "\xDA\x91",
					"\x9B" => "\xE2\x80\xBA",
					"\x9C" => "\xC5\x93",
					"\x9D" => "\xE2\x80\x8C",
					"\x9E" => "\xE2\x80\x8D",
					"\x9F" => "\xDA\xBA",
					"\xA0" => "\xC2\xA0",
					"\xA1" => "\xD8\x8C",
					"\xA2" => "\xC2\xA2",
					"\xA3" => "\xC2\xA3",
					"\xA4" => "\xC2\xA4",
					"\xA5" => "\xC2\xA5",
					"\xA6" => "\xC2\xA6",
					"\xA7" => "\xC2\xA7",
					"\xA8" => "\xC2\xA8",
					"\xA9" => "\xC2\xA9",
					"\xAA" => "\xDA\xBE",
					"\xAB" => "\xC2\xAB",
					"\xAC" => "\xC2\xAC",
					"\xAD" => "\xC2\xAD",
					"\xAE" => "\xC2\xAE",
					"\xAF" => "\xC2\xAF",
					"\xB0" => "\xC2\xB0",
					"\xB1" => "\xC2\xB1",
					"\xB2" => "\xC2\xB2",
					"\xB3" => "\xC2\xB3",
					"\xB4" => "\xC2\xB4",
					"\xB5" => "\xC2\xB5",
					"\xB6" => "\xC2\xB6",
					"\xB7" => "\xC2\xB7",
					"\xB8" => "\xC2\xB8",
					"\xB9" => "\xC2\xB9",
					"\xBA" => "\xD8\x9B",
					"\xBB" => "\xC2\xBB",
					"\xBC" => "\xC2\xBC",
					"\xBD" => "\xC2\xBD",
					"\xBE" => "\xC2\xBE",
					"\xBF" => "\xD8\x9F",
					"\xC0" => "\xDB\x81",
					"\xC1" => "\xD8\xA1",
					"\xC2" => "\xD8\xA2",
					"\xC3" => "\xD8\xA3",
					"\xC4" => "\xD8\xA4",
					"\xC5" => "\xD8\xA5",
					"\xC6" => "\xD8\xA6",
					"\xC7" => "\xD8\xA7",
					"\xC8" => "\xD8\xA8",
					"\xC9" => "\xD8\xA9",
					"\xCA" => "\xD8\xAA",
					"\xCB" => "\xD8\xAB",
					"\xCC" => "\xD8\xAC",
					"\xCD" => "\xD8\xAD",
					"\xCE" => "\xD8\xAE",
					"\xCF" => "\xD8\xAF",
					"\xD0" => "\xD8\xB0",
					"\xD1" => "\xD8\xB1",
					"\xD2" => "\xD8\xB2",
					"\xD3" => "\xD8\xB3",
					"\xD4" => "\xD8\xB4",
					"\xD5" => "\xD8\xB5",
					"\xD6" => "\xD8\xB6",
					"\xD7" => "\xC3\x97",
					"\xD8" => "\xD8\xB7",
					"\xD9" => "\xD8\xB8",
					"\xDA" => "\xD8\xB9",
					"\xDB" => "\xD8\xBA",
					"\xDC" => "\xD9\x80",
					"\xDD" => "\xD9\x81",
					"\xDE" => "\xD9\x82",
					"\xDF" => "\xD9\x83",
					"\xE0" => "\xC3\xA0",
					"\xE1" => "\xD9\x84",
					"\xE2" => "\xC3\xA2",
					"\xE3" => "\xD9\x85",
					"\xE4" => "\xD9\x86",
					"\xE5" => "\xD9\x87",
					"\xE6" => "\xD9\x88",
					"\xE7" => "\xC3\xA7",
					"\xE8" => "\xC3\xA8",
					"\xE9" => "\xC3\xA9",
					"\xEA" => "\xC3\xAA",
					"\xEB" => "\xC3\xAB",
					"\xEC" => "\xD9\x89",
					"\xED" => "\xD9\x8A",
					"\xEE" => "\xC3\xAE",
					"\xEF" => "\xC3\xAF",
					"\xF0" => "\xD9\x8B",
					"\xF1" => "\xD9\x8C",
					"\xF2" => "\xD9\x8D",
					"\xF3" => "\xD9\x8E",
					"\xF4" => "\xC3\xB4",
					"\xF5" => "\xD9\x8F",
					"\xF6" => "\xD9\x90",
					"\xF7" => "\xC3\xB7",
					"\xF8" => "\xD9\x91",
					"\xF9" => "\xC3\xB9",
					"\xFA" => "\xD9\x92",
					"\xFB" => "\xC3\xBB",
					"\xFC" => "\xC3\xBC",
					"\xFD" => "\xE2\x80\x8E",
					"\xFE" => "\xE2\x80\x8F",
					"\xFF" => "\xDB\x92");

		$outStr = '';
    	for ($i = 0, $len = strlen($string); $i < $len; $i++)
    	{
    		$outStr .= (array_key_exists($string{$i}, $mapping))?$mapping[$string{$i}]:$string{$i};
		}
		
		return $outStr;
	}

