<?php

	/**
	 * Original data taken from:
	 * ftp://ftp.unicode.org/Public/MAPPINGS/VENDORS/MICSFT/WINDOWS/CP1258.TXT
	 * @param string $string
	 * @return string
	 */
	function charset_decode_windows_1258($string)
	{
		$mapping = array(
					"\x80" => "\xE2\x82\xAC",
					"\x82" => "\xE2\x80\x9A",
					"\x83" => "\xC6\x92",
					"\x84" => "\xE2\x80\x9E",
					"\x85" => "\xE2\x80\xA6",
					"\x86" => "\xE2\x80\xA0",
					"\x87" => "\xE2\x80\xA1",
					"\x88" => "\xCB\x86",
					"\x89" => "\xE2\x80\xB0",
					"\x8B" => "\xE2\x80\xB9",
					"\x8C" => "\xC5\x92",
					"\x91" => "\xE2\x80\x98",
					"\x92" => "\xE2\x80\x99",
					"\x93" => "\xE2\x80\x9C",
					"\x94" => "\xE2\x80\x9D",
					"\x95" => "\xE2\x80\xA2",
					"\x96" => "\xE2\x80\x93",
					"\x97" => "\xE2\x80\x94",
					"\x98" => "\xCB\x9C",
					"\x99" => "\xE2\x84\xA2",
					"\x9B" => "\xE2\x80\xBA",
					"\x9C" => "\xC5\x93",
					"\x9F" => "\xC5\xB8",
					"\xA0" => "\xC2\xA0",
					"\xA1" => "\xC2\xA1",
					"\xA2" => "\xC2\xA2",
					"\xA3" => "\xC2\xA3",
					"\xA4" => "\xC2\xA4",
					"\xA5" => "\xC2\xA5",
					"\xA6" => "\xC2\xA6",
					"\xA7" => "\xC2\xA7",
					"\xA8" => "\xC2\xA8",
					"\xA9" => "\xC2\xA9",
					"\xAA" => "\xC2\xAA",
					"\xAB" => "\xC2\xAB",
					"\xAC" => "\xC2\xAC",
					"\xAD" => "\xC2\xAD",
					"\xAE" => "\xC2\xAE",
					"\xAF" => "\xC2\xAF",
					"\xB0" => "\xC2\xB0",
					"\xB1" => "\xC2\xB1",
					"\xB2" => "\xC2\xB2",
					"\xB3" => "\xC2\xB3",
					"\xB4" => "\xC2\xB4",
					"\xB5" => "\xC2\xB5",
					"\xB6" => "\xC2\xB6",
					"\xB7" => "\xC2\xB7",
					"\xB8" => "\xC2\xB8",
					"\xB9" => "\xC2\xB9",
					"\xBA" => "\xC2\xBA",
					"\xBB" => "\xC2\xBB",
					"\xBC" => "\xC2\xBC",
					"\xBD" => "\xC2\xBD",
					"\xBE" => "\xC2\xBE",
					"\xBF" => "\xC2\xBF",
					"\xC0" => "\xC3\x80",
					"\xC1" => "\xC3\x81",
					"\xC2" => "\xC3\x82",
					"\xC3" => "\xC4\x82",
					"\xC4" => "\xC3\x84",
					"\xC5" => "\xC3\x85",
					"\xC6" => "\xC3\x86",
					"\xC7" => "\xC3\x87",
					"\xC8" => "\xC3\x88",
					"\xC9" => "\xC3\x89",
					"\xCA" => "\xC3\x8A",
					"\xCB" => "\xC3\x8B",
					"\xCC" => "\xCC\x80",
					"\xCD" => "\xC3\x8D",
					"\xCE" => "\xC3\x8E",
					"\xCF" => "\xC3\x8F",
					"\xD0" => "\xC4\x90",
					"\xD1" => "\xC3\x91",
					"\xD2" => "\xCC\x89",
					"\xD3" => "\xC3\x93",
					"\xD4" => "\xC3\x94",
					"\xD5" => "\xC6\xA0",
					"\xD6" => "\xC3\x96",
					"\xD7" => "\xC3\x97",
					"\xD8" => "\xC3\x98",
					"\xD9" => "\xC3\x99",
					"\xDA" => "\xC3\x9A",
					"\xDB" => "\xC3\x9B",
					"\xDC" => "\xC3\x9C",
					"\xDD" => "\xC6\xAF",
					"\xDE" => "\xCC\x83",
					"\xDF" => "\xC3\x9F",
					"\xE0" => "\xC3\xA0",
					"\xE1" => "\xC3\xA1",
					"\xE2" => "\xC3\xA2",
					"\xE3" => "\xC4\x83",
					"\xE4" => "\xC3\xA4",
					"\xE5" => "\xC3\xA5",
					"\xE6" => "\xC3\xA6",
					"\xE7" => "\xC3\xA7",
					"\xE8" => "\xC3\xA8",
					"\xE9" => "\xC3\xA9",
					"\xEA" => "\xC3\xAA",
					"\xEB" => "\xC3\xAB",
					"\xEC" => "\xCC\x81",
					"\xED" => "\xC3\xAD",
					"\xEE" => "\xC3\xAE",
					"\xEF" => "\xC3\xAF",
					"\xF0" => "\xC4\x91",
					"\xF1" => "\xC3\xB1",
					"\xF2" => "\xCC\xA3",
					"\xF3" => "\xC3\xB3",
					"\xF4" => "\xC3\xB4",
					"\xF5" => "\xC6\xA1",
					"\xF6" => "\xC3\xB6",
					"\xF7" => "\xC3\xB7",
					"\xF8" => "\xC3\xB8",
					"\xF9" => "\xC3\xB9",
					"\xFA" => "\xC3\xBA",
					"\xFB" => "\xC3\xBB",
					"\xFC" => "\xC3\xBC",
					"\xFD" => "\xC6\xB0",
					"\xFE" => "\xE2\x82\xAB",
					"\xFF" => "\xC3\xBF");

		$outStr = '';
    	for ($i = 0, $len = strlen($string); $i < $len; $i++)
    	{
    		$outStr .= (array_key_exists($string{$i}, $mapping))?$mapping[$string{$i}]:$string{$i};
		}
		
		return $outStr;
	}

