<?php

	/**
	 * Original data taken from:
	 * ftp://ftp.unicode.org/Public/MAPPINGS/VENDORS/MICSFT/PC/CP855.TXT
	 * @param string $string
	 * @return string
	 */
	function charset_encode_cp855($string)
	{
		$mapping = array(
					"\xD1\x92" => "\x80",
					"\xD0\x82" => "\x81",
					"\xD1\x93" => "\x82",
					"\xD0\x83" => "\x83",
					"\xD1\x91" => "\x84",
					"\xD0\x81" => "\x85",
					"\xD1\x94" => "\x86",
					"\xD0\x84" => "\x87",
					"\xD1\x95" => "\x88",
					"\xD0\x85" => "\x89",
					"\xD1\x96" => "\x8A",
					"\xD0\x86" => "\x8B",
					"\xD1\x97" => "\x8C",
					"\xD0\x87" => "\x8D",
					"\xD1\x98" => "\x8E",
					"\xD0\x88" => "\x8F",
					"\xD1\x99" => "\x90",
					"\xD0\x89" => "\x91",
					"\xD1\x9A" => "\x92",
					"\xD0\x8A" => "\x93",
					"\xD1\x9B" => "\x94",
					"\xD0\x8B" => "\x95",
					"\xD1\x9C" => "\x96",
					"\xD0\x8C" => "\x97",
					"\xD1\x9E" => "\x98",
					"\xD0\x8E" => "\x99",
					"\xD1\x9F" => "\x9A",
					"\xD0\x8F" => "\x9B",
					"\xD1\x8E" => "\x9C",
					"\xD0\xAE" => "\x9D",
					"\xD1\x8A" => "\x9E",
					"\xD0\xAA" => "\x9F",
					"\xD0\xB0" => "\xA0",
					"\xD0\x90" => "\xA1",
					"\xD0\xB1" => "\xA2",
					"\xD0\x91" => "\xA3",
					"\xD1\x86" => "\xA4",
					"\xD0\xA6" => "\xA5",
					"\xD0\xB4" => "\xA6",
					"\xD0\x94" => "\xA7",
					"\xD0\xB5" => "\xA8",
					"\xD0\x95" => "\xA9",
					"\xD1\x84" => "\xAA",
					"\xD0\xA4" => "\xAB",
					"\xD0\xB3" => "\xAC",
					"\xD0\x93" => "\xAD",
					"\xC2\xAB" => "\xAE",
					"\xC2\xBB" => "\xAF",
					"\xE2\x96\x91" => "\xB0",
					"\xE2\x96\x92" => "\xB1",
					"\xE2\x96\x93" => "\xB2",
					"\xE2\x94\x82" => "\xB3",
					"\xE2\x94\xA4" => "\xB4",
					"\xD1\x85" => "\xB5",
					"\xD0\xA5" => "\xB6",
					"\xD0\xB8" => "\xB7",
					"\xD0\x98" => "\xB8",
					"\xE2\x95\xA3" => "\xB9",
					"\xE2\x95\x91" => "\xBA",
					"\xE2\x95\x97" => "\xBB",
					"\xE2\x95\x9D" => "\xBC",
					"\xD0\xB9" => "\xBD",
					"\xD0\x99" => "\xBE",
					"\xE2\x94\x90" => "\xBF",
					"\xE2\x94\x94" => "\xC0",
					"\xE2\x94\xB4" => "\xC1",
					"\xE2\x94\xAC" => "\xC2",
					"\xE2\x94\x9C" => "\xC3",
					"\xE2\x94\x80" => "\xC4",
					"\xE2\x94\xBC" => "\xC5",
					"\xD0\xBA" => "\xC6",
					"\xD0\x9A" => "\xC7",
					"\xE2\x95\x9A" => "\xC8",
					"\xE2\x95\x94" => "\xC9",
					"\xE2\x95\xA9" => "\xCA",
					"\xE2\x95\xA6" => "\xCB",
					"\xE2\x95\xA0" => "\xCC",
					"\xE2\x95\x90" => "\xCD",
					"\xE2\x95\xAC" => "\xCE",
					"\xC2\xA4" => "\xCF",
					"\xD0\xBB" => "\xD0",
					"\xD0\x9B" => "\xD1",
					"\xD0\xBC" => "\xD2",
					"\xD0\x9C" => "\xD3",
					"\xD0\xBD" => "\xD4",
					"\xD0\x9D" => "\xD5",
					"\xD0\xBE" => "\xD6",
					"\xD0\x9E" => "\xD7",
					"\xD0\xBF" => "\xD8",
					"\xE2\x94\x98" => "\xD9",
					"\xE2\x94\x8C" => "\xDA",
					"\xE2\x96\x88" => "\xDB",
					"\xE2\x96\x84" => "\xDC",
					"\xD0\x9F" => "\xDD",
					"\xD1\x8F" => "\xDE",
					"\xE2\x96\x80" => "\xDF",
					"\xD0\xAF" => "\xE0",
					"\xD1\x80" => "\xE1",
					"\xD0\xA0" => "\xE2",
					"\xD1\x81" => "\xE3",
					"\xD0\xA1" => "\xE4",
					"\xD1\x82" => "\xE5",
					"\xD0\xA2" => "\xE6",
					"\xD1\x83" => "\xE7",
					"\xD0\xA3" => "\xE8",
					"\xD0\xB6" => "\xE9",
					"\xD0\x96" => "\xEA",
					"\xD0\xB2" => "\xEB",
					"\xD0\x92" => "\xEC",
					"\xD1\x8C" => "\xED",
					"\xD0\xAC" => "\xEE",
					"\xE2\x84\x96" => "\xEF",
					"\xC2\xAD" => "\xF0",
					"\xD1\x8B" => "\xF1",
					"\xD0\xAB" => "\xF2",
					"\xD0\xB7" => "\xF3",
					"\xD0\x97" => "\xF4",
					"\xD1\x88" => "\xF5",
					"\xD0\xA8" => "\xF6",
					"\xD1\x8D" => "\xF7",
					"\xD0\xAD" => "\xF8",
					"\xD1\x89" => "\xF9",
					"\xD0\xA9" => "\xFA",
					"\xD1\x87" => "\xFB",
					"\xD0\xA7" => "\xFC",
					"\xC2\xA7" => "\xFD",
					"\xE2\x96\xA0" => "\xFE",
					"\xC2\xA0" => "\xFF");

		return str_replace(array_keys($mapping), array_values($mapping), $string);
	}

