<?php

	/**
	 * Original data taken from:
	 * ftp://ftp.unicode.org/Public/MAPPINGS/ISO8859/8859-11.TXT
	 * @param string $string
	 * @return string
	 */
	function charset_encode_iso_8859_11($string)
	{
		$mapping = array(
					"\xC2\x80" => "\x80",
					"\xC2\x81" => "\x81",
					"\xC2\x82" => "\x82",
					"\xC2\x83" => "\x83",
					"\xC2\x84" => "\x84",
					"\xC2\x85" => "\x85",
					"\xC2\x86" => "\x86",
					"\xC2\x87" => "\x87",
					"\xC2\x88" => "\x88",
					"\xC2\x89" => "\x89",
					"\xC2\x8A" => "\x8A",
					"\xC2\x8B" => "\x8B",
					"\xC2\x8C" => "\x8C",
					"\xC2\x8D" => "\x8D",
					"\xC2\x8E" => "\x8E",
					"\xC2\x8F" => "\x8F",
					"\xC2\x90" => "\x90",
					"\xC2\x91" => "\x91",
					"\xC2\x92" => "\x92",
					"\xC2\x93" => "\x93",
					"\xC2\x94" => "\x94",
					"\xC2\x95" => "\x95",
					"\xC2\x96" => "\x96",
					"\xC2\x97" => "\x97",
					"\xC2\x98" => "\x98",
					"\xC2\x99" => "\x99",
					"\xC2\x9A" => "\x9A",
					"\xC2\x9B" => "\x9B",
					"\xC2\x9C" => "\x9C",
					"\xC2\x9D" => "\x9D",
					"\xC2\x9E" => "\x9E",
					"\xC2\x9F" => "\x9F",
					"\xC2\xA0" => "\xA0",
					"\xE0\xB8\x81" => "\xA1",
					"\xE0\xB8\x82" => "\xA2",
					"\xE0\xB8\x83" => "\xA3",
					"\xE0\xB8\x84" => "\xA4",
					"\xE0\xB8\x85" => "\xA5",
					"\xE0\xB8\x86" => "\xA6",
					"\xE0\xB8\x87" => "\xA7",
					"\xE0\xB8\x88" => "\xA8",
					"\xE0\xB8\x89" => "\xA9",
					"\xE0\xB8\x8A" => "\xAA",
					"\xE0\xB8\x8B" => "\xAB",
					"\xE0\xB8\x8C" => "\xAC",
					"\xE0\xB8\x8D" => "\xAD",
					"\xE0\xB8\x8E" => "\xAE",
					"\xE0\xB8\x8F" => "\xAF",
					"\xE0\xB8\x90" => "\xB0",
					"\xE0\xB8\x91" => "\xB1",
					"\xE0\xB8\x92" => "\xB2",
					"\xE0\xB8\x93" => "\xB3",
					"\xE0\xB8\x94" => "\xB4",
					"\xE0\xB8\x95" => "\xB5",
					"\xE0\xB8\x96" => "\xB6",
					"\xE0\xB8\x97" => "\xB7",
					"\xE0\xB8\x98" => "\xB8",
					"\xE0\xB8\x99" => "\xB9",
					"\xE0\xB8\x9A" => "\xBA",
					"\xE0\xB8\x9B" => "\xBB",
					"\xE0\xB8\x9C" => "\xBC",
					"\xE0\xB8\x9D" => "\xBD",
					"\xE0\xB8\x9E" => "\xBE",
					"\xE0\xB8\x9F" => "\xBF",
					"\xE0\xB8\xA0" => "\xC0",
					"\xE0\xB8\xA1" => "\xC1",
					"\xE0\xB8\xA2" => "\xC2",
					"\xE0\xB8\xA3" => "\xC3",
					"\xE0\xB8\xA4" => "\xC4",
					"\xE0\xB8\xA5" => "\xC5",
					"\xE0\xB8\xA6" => "\xC6",
					"\xE0\xB8\xA7" => "\xC7",
					"\xE0\xB8\xA8" => "\xC8",
					"\xE0\xB8\xA9" => "\xC9",
					"\xE0\xB8\xAA" => "\xCA",
					"\xE0\xB8\xAB" => "\xCB",
					"\xE0\xB8\xAC" => "\xCC",
					"\xE0\xB8\xAD" => "\xCD",
					"\xE0\xB8\xAE" => "\xCE",
					"\xE0\xB8\xAF" => "\xCF",
					"\xE0\xB8\xB0" => "\xD0",
					"\xE0\xB8\xB1" => "\xD1",
					"\xE0\xB8\xB2" => "\xD2",
					"\xE0\xB8\xB3" => "\xD3",
					"\xE0\xB8\xB4" => "\xD4",
					"\xE0\xB8\xB5" => "\xD5",
					"\xE0\xB8\xB6" => "\xD6",
					"\xE0\xB8\xB7" => "\xD7",
					"\xE0\xB8\xB8" => "\xD8",
					"\xE0\xB8\xB9" => "\xD9",
					"\xE0\xB8\xBA" => "\xDA",
					"\xE0\xB8\xBF" => "\xDF",
					"\xE0\xB9\x80" => "\xE0",
					"\xE0\xB9\x81" => "\xE1",
					"\xE0\xB9\x82" => "\xE2",
					"\xE0\xB9\x83" => "\xE3",
					"\xE0\xB9\x84" => "\xE4",
					"\xE0\xB9\x85" => "\xE5",
					"\xE0\xB9\x86" => "\xE6",
					"\xE0\xB9\x87" => "\xE7",
					"\xE0\xB9\x88" => "\xE8",
					"\xE0\xB9\x89" => "\xE9",
					"\xE0\xB9\x8A" => "\xEA",
					"\xE0\xB9\x8B" => "\xEB",
					"\xE0\xB9\x8C" => "\xEC",
					"\xE0\xB9\x8D" => "\xED",
					"\xE0\xB9\x8E" => "\xEE",
					"\xE0\xB9\x8F" => "\xEF",
					"\xE0\xB9\x90" => "\xF0",
					"\xE0\xB9\x91" => "\xF1",
					"\xE0\xB9\x92" => "\xF2",
					"\xE0\xB9\x93" => "\xF3",
					"\xE0\xB9\x94" => "\xF4",
					"\xE0\xB9\x95" => "\xF5",
					"\xE0\xB9\x96" => "\xF6",
					"\xE0\xB9\x97" => "\xF7",
					"\xE0\xB9\x98" => "\xF8",
					"\xE0\xB9\x99" => "\xF9",
					"\xE0\xB9\x9A" => "\xFA",
					"\xE0\xB9\x9B" => "\xFB");

		return str_replace(array_keys($mapping), array_values($mapping), $string);
	}

