<?php

/*
 * AfterLogic WebMail Pro PHP by AfterLogic Corp. <support@afterlogic.com>
 *
 * Copyright (C) 2002-2010  AfterLogic Corp. (www.afterlogic.com)
 * Distributed under the terms of the license described in COPYING
 * 
 */

	@header('Content-type: application/x-javascript; charset=utf-8');

	defined('WM_ROOTPATH') || define('WM_ROOTPATH', (dirname(__FILE__).'/'));

	require_once(WM_ROOTPATH.'common/inc_top.php');
	require_once(WM_ROOTPATH.'common/inc_constants.php');
	require_once(WM_ROOTPATH.'common/last_modified.php');
	require_once(WM_ROOTPATH.'common/class_settings.php');

	@ob_start(USE_JS_GZIP ? 'obStartGzip' : 'obStartNoGzip');
	
	$lang = isset($_GET['lang']) ? $_GET['lang'] : '';

	$settings =& Settings::CreateInstance();
	if (!$settings || !$settings->isLoad || !$settings->IncludeLang($lang))
	{
		require_once(WM_ROOTPATH.'common/class_log.php');
		
		$log =& CLog::CreateInstance();
		$log->WriteLine('::: JS Lang file Error :::', LOG_LEVEL_ERROR);
		exit();
	}
	
	/**
	 * @param string $str
	 * @return string
	 */
	function quot($str)
	{
		return str_replace('\'', '\\\'', str_replace('\\', '\\\\', $str));
	}

?>Lang = {
	TitleLogin: '<?php echo quot(JS_LANG_TitleLogin);?>',
	TitleMessagesListView: '<?php echo quot(JS_LANG_TitleMessagesListView);?>',
	TitleMessagesList: '<?php echo quot(JS_LANG_TitleMessagesList);?>',
	TitleViewMessage: '<?php echo quot(JS_LANG_TitleViewMessage);?>',
	TitleNewMessage: '<?php echo quot(JS_LANG_TitleNewMessage);?>',
	TitleSettings: '<?php echo quot(JS_LANG_TitleSettings);?>',
	TitleContacts: '<?php echo quot(JS_LANG_TitleContacts);?>',
	StandardLogin: '<?php echo quot(JS_LANG_StandardLogin);?>',
	AdvancedLogin: '<?php echo quot(JS_LANG_AdvancedLogin);?>',
	InfoWebMailLoading: '<?php echo quot(JS_LANG_InfoWebMailLoading);?>',
	Loading: '<?php echo quot(JS_LANG_Loading);?>',
	InfoMessagesLoad: '<?php echo quot(JS_LANG_InfoMessagesLoad);?>',
	InfoEmptyFolder: '<?php echo quot(JS_LANG_InfoEmptyFolder);?>',
	InfoPageLoading: '<?php echo quot(JS_LANG_InfoPageLoading);?>',
	InfoSendMessage: '<?php echo quot(JS_LANG_InfoSendMessage);?>',
	InfoSaveMessage: '<?php echo quot(JS_LANG_InfoSaveMessage);?>',
	InfoHaveImported: '<?php echo quot(JS_LANG_InfoHaveImported);?>',
	InfoNewContacts: '<?php echo quot(JS_LANG_InfoNewContacts);?>',
	InfoToDelete: '<?php echo quot(JS_LANG_InfoToDelete);?>',
	InfoDeleteContent: '<?php echo quot(JS_LANG_InfoDeleteContent);?>',
	InfoDeleteNotEmptyFolders: '<?php echo quot(JS_LANG_InfoDeleteNotEmptyFolders);?>',
	InfoRequiredFields: '<?php echo quot(JS_LANG_InfoRequiredFields);?>',
	ConfirmAreYouSure: '<?php echo quot(JS_LANG_ConfirmAreYouSure);?>',
	ConfirmDirectModeAreYouSure: '<?php echo quot(JS_LANG_ConfirmDirectModeAreYouSure);?>',
	ConfirmSaveSettings: '<?php echo quot(JS_LANG_ConfirmSaveSettings);?>',
	ConfirmSaveContactsSettings: '<?php echo quot(JS_LANG_ConfirmSaveContactsSettings);?>',
	ConfirmSaveAcctProp: '<?php echo quot(JS_LANG_ConfirmSaveAcctProp);?>',
	ConfirmSaveFilter: '<?php echo quot(JS_LANG_ConfirmSaveFilter);?>',
	ConfirmSaveSignature: '<?php echo quot(JS_LANG_ConfirmSaveSignature);?>',
	ConfirmSavefolders: '<?php echo quot(JS_LANG_ConfirmSavefolders);?>',
	ConfirmHtmlToPlain: '<?php echo quot(JS_LANG_ConfirmHtmlToPlain);?>',
	ConfirmAddFolder: '<?php echo quot(JS_LANG_ConfirmAddFolder);?>',
	ConfirmEmptySubject: '<?php echo quot(JS_LANG_ConfirmEmptySubject);?>',
	WarningEmailBlank: '<?php echo quot(JS_LANG_WarningEmailBlank);?>',
	WarningLoginBlank: '<?php echo quot(JS_LANG_WarningLoginBlank);?>',
	WarningToBlank: '<?php echo quot(JS_LANG_WarningToBlank);?>',
	WarningServerPortBlank: '<?php echo quot(JS_LANG_WarningServerPortBlank);?>',
	WarningEmptySearchLine: '<?php echo quot(JS_LANG_WarningEmptySearchLine);?>',
	WarningMarkListItem: '<?php echo quot(JS_LANG_WarningMarkListItem);?>',
	WarningFolderMove: '<?php echo quot(JS_LANG_WarningFolderMove);?>',
	WarningContactNotComplete: '<?php echo quot(JS_LANG_WarningContactNotComplete);?>',
	WarningGroupNotComplete: '<?php echo quot(JS_LANG_WarningGroupNotComplete);?>',
	WarningEmailFieldBlank: '<?php echo quot(JS_LANG_WarningEmailFieldBlank);?>',
	WarningIncServerBlank: '<?php echo quot(JS_LANG_WarningIncServerBlank);?>',
	WarningIncPortBlank: '<?php echo quot(JS_LANG_WarningIncPortBlank);?>',
	WarningIncLoginBlank: '<?php echo quot(JS_LANG_WarningIncLoginBlank);?>',
	WarningIncPortNumber: '<?php echo quot(JS_LANG_WarningIncPortNumber);?>',
	DefaultIncPortNumber: '<?php echo quot(JS_LANG_DefaultIncPortNumber);?>',
	WarningIncPassBlank: '<?php echo quot(JS_LANG_WarningIncPassBlank);?>',
	WarningOutPortBlank: '<?php echo quot(JS_LANG_WarningOutPortBlank);?>',
	WarningOutPortNumber: '<?php echo quot(JS_LANG_WarningOutPortNumber);?>',
	DefaultOutPortNumber: '<?php echo quot(JS_LANG_DefaultOutPortNumber);?>',
	WarningCorrectEmail: '<?php echo quot(JS_LANG_WarningCorrectEmail);?>',
	WarningCsvExtention: '<?php echo quot(JS_LANG_WarningCsvExtention);?>',
	WarningImportFileType: '<?php echo quot(JS_LANG_WarningImportFileType);?>',
	WarningEmptyImportFile: '<?php echo quot(JS_LANG_WarningEmptyImportFile);?>',
	WarningContactsPerPage: '<?php echo quot(JS_LANG_WarningContactsPerPage);?>',
	WarningMessagesPerPage: '<?php echo quot(JS_LANG_WarningMessagesPerPage);?>',
	WarningMailsOnServerDays: '<?php echo quot(JS_LANG_WarningMailsOnServerDays);?>',
	WarningEmptyFilter: '<?php echo quot(JS_LANG_WarningEmptyFilter);?>',
	WarningEmptyFolderName: '<?php echo quot(JS_LANG_WarningEmptyFolderName);?>',
	WarningCantCreateAccount: '<?php echo quot(CantCreateAccount);?>',
	WarningCantUpdateAccount: '<?php echo quot(PROC_CANT_UPDATE_ACCT);?>',
	WarningCantCreateFolder: '<?php echo quot(PROC_CANT_CREATE_FLD);?>',
	WarningCantUpdateFolder: '<?php echo quot(PROC_CANT_UPD_FLD);?>',
	ErrorConnectionFailed: '<?php echo quot(JS_LANG_ErrorConnectionFailed);?>',
	ErrorRequestFailed: '<?php echo quot(JS_LANG_ErrorRequestFailed);?>',
	ErrorAbsentXMLHttpRequest: '<?php echo quot(JS_LANG_ErrorAbsentXMLHttpRequest);?>',
	ErrorWithoutDesc: '<?php echo quot(JS_LANG_ErrorWithoutDesc);?>',
	ErrorParsing: '<?php echo quot(JS_LANG_ErrorParsing);?>',
	ResponseText: '<?php echo quot(JS_LANG_ResponseText);?>',
	ErrorEmptyXmlPacket: '<?php echo quot(JS_LANG_ErrorEmptyXmlPacket);?>',
	ErrorImportContacts: '<?php echo quot(JS_LANG_ErrorImportContacts);?>',
	ErrorNoContacts: '<?php echo quot(JS_LANG_ErrorNoContacts);?>',
	ErrorCheckMail: '<?php echo quot(JS_LANG_ErrorCheckMail);?>',
	LoggingToServer: '<?php echo quot(JS_LANG_LoggingToServer);?>',
	GettingMsgsNum: '<?php echo quot(JS_LANG_GettingMsgsNum);?>',
	RetrievingMessage: '<?php echo quot(JS_LANG_RetrievingMessage);?>',
	DeletingMessage: '<?php echo quot(JS_LANG_DeletingMessage);?>',
	DeletingMessages: '<?php echo quot(JS_LANG_DeletingMessages);?>',
	Of: '<?php echo quot(JS_LANG_Of);?>',
	Connection: '<?php echo quot(JS_LANG_Connection);?>',
	Charset: '<?php echo quot(JS_LANG_Charset);?>',
	AutoSelect: '<?php echo quot(JS_LANG_AutoSelect);?>',
	Contacts: '<?php echo quot(JS_LANG_Contacts);?>',
	ClassicVersion: '<?php echo quot(JS_LANG_ClassicVersion);?>',
	Logout: '<?php echo quot(JS_LANG_Logout);?>',
	Settings: '<?php echo quot(JS_LANG_Settings);?>',
	LookFor: '<?php echo quot(JS_LANG_LookFor);?>',
	SearchIn: '<?php echo quot(JS_LANG_SearchIn);?>',
	QuickSearch: '<?php echo quot(JS_LANG_QuickSearch);?>',
	SlowSearch: '<?php echo quot(JS_LANG_SlowSearch);?>',
	AllMailFolders: '<?php echo quot(JS_LANG_AllMailFolders);?>',
	AllGroups: '<?php echo quot(JS_LANG_AllGroups);?>',
	NewMessage: '<?php echo quot(JS_LANG_NewMessage);?>',
	CheckMail: '<?php echo quot(JS_LANG_CheckMail);?>',
	ReloadFolders: '<?php echo quot(JS_LANG_ReloadFolders);?>',
	EmptyTrash: '<?php echo quot(JS_LANG_EmptyTrash);?>',
	MarkAsRead: '<?php echo quot(JS_LANG_MarkAsRead);?>',
	MarkAsUnread: '<?php echo quot(JS_LANG_MarkAsUnread);?>',
	MarkFlag: '<?php echo quot(JS_LANG_MarkFlag);?>',
	MarkUnflag: '<?php echo quot(JS_LANG_MarkUnflag);?>',
	MarkAllRead: '<?php echo quot(JS_LANG_MarkAllRead);?>',
	MarkAllUnread: '<?php echo quot(JS_LANG_MarkAllUnread);?>',
	Reply: '<?php echo quot(JS_LANG_Reply);?>',
	ReplyAll: '<?php echo quot(JS_LANG_ReplyAll);?>',
	Delete: '<?php echo quot(JS_LANG_Delete);?>',
	Undelete: '<?php echo quot(JS_LANG_Undelete);?>',
	PurgeDeleted: '<?php echo quot(JS_LANG_PurgeDeleted);?>',
	MoveToFolder: '<?php echo quot(JS_LANG_MoveToFolder);?>',
	Forward: '<?php echo quot(JS_LANG_Forward);?>',
	HideFolders: '<?php echo quot(JS_LANG_HideFolders);?>',
	ShowFolders: '<?php echo quot(JS_LANG_ShowFolders);?>',
	ManageFolders: '<?php echo quot(JS_LANG_ManageFolders);?>',
	SyncFolder: '<?php echo quot(JS_LANG_SyncFolder);?>',
	NewMessages: '<?php echo quot(JS_LANG_NewMessages);?>',
	Messages: '<?php echo quot(JS_LANG_Messages);?>',
	From: '<?php echo quot(JS_LANG_From);?>',
	To: '<?php echo quot(JS_LANG_To);?>',
	Date: '<?php echo quot(JS_LANG_Date);?>',
	Size: '<?php echo quot(JS_LANG_Size);?>',
	Subject: '<?php echo quot(JS_LANG_Subject);?>',
	FirstPage: '<?php echo quot(JS_LANG_FirstPage);?>',
	PreviousPage: '<?php echo quot(JS_LANG_PreviousPage);?>',
	NextPage: '<?php echo quot(JS_LANG_NextPage);?>',
	LastPage: '<?php echo quot(JS_LANG_LastPage);?>',
	SwitchToPlain: '<?php echo quot(JS_LANG_SwitchToPlain);?>',
	SwitchToHTML: '<?php echo quot(JS_LANG_SwitchToHTML);?>',
	AddToAddressBook: '<?php echo quot(JS_LANG_AddToAddressBook);?>',
	ClickToDownload: '<?php echo quot(JS_LANG_ClickToDownload);?>',
	View: '<?php echo quot(JS_LANG_View);?>',
	ShowFullHeaders: '<?php echo quot(JS_LANG_ShowFullHeaders);?>',
	HideFullHeaders: '<?php echo quot(JS_LANG_HideFullHeaders);?>',
	MessagesInFolder: '<?php echo quot(JS_LANG_MessagesInFolder);?>',
	YouUsing: '<?php echo quot(JS_LANG_YouUsing);?>',
	OfYour: '<?php echo quot(JS_LANG_OfYour);?>',
	Mb: '<?php echo quot(JS_LANG_Mb);?>',
	Kb: '<?php echo quot(JS_LANG_Kb);?>',
	B: '<?php echo quot(JS_LANG_B);?>',
	SendMessage: '<?php echo quot(JS_LANG_SendMessage);?>',
	SaveMessage: '<?php echo quot(JS_LANG_SaveMessage);?>',
	Print: '<?php echo quot(JS_LANG_Print);?>',
	PreviousMsg: '<?php echo quot(JS_LANG_PreviousMsg);?>',
	NextMsg: '<?php echo quot(JS_LANG_NextMsg);?>',
	AddressBook: '<?php echo quot(JS_LANG_AddressBook);?>',
	ShowBCC: '<?php echo quot(JS_LANG_ShowBCC);?>',
	HideBCC: '<?php echo quot(JS_LANG_HideBCC);?>',
	CC: '<?php echo quot(JS_LANG_CC);?>',
	BCC: '<?php echo quot(JS_LANG_BCC);?>',
	ReplyTo: '<?php echo quot(JS_LANG_ReplyTo);?>',
	AttachFile: '<?php echo quot(JS_LANG_AttachFile);?>',
	Attach: '<?php echo quot(JS_LANG_Attach);?>',
	Re: '<?php echo quot(JS_LANG_Re);?>',
	OriginalMessage: '<?php echo quot(JS_LANG_OriginalMessage);?>',
	Sent: '<?php echo quot(JS_LANG_Sent);?>',
	Fwd: '<?php echo quot(JS_LANG_Fwd);?>',
	Low: '<?php echo quot(JS_LANG_Low);?>',
	Normal: '<?php echo quot(JS_LANG_Normal);?>',
	High: '<?php echo quot(JS_LANG_High);?>',
	Importance: '<?php echo quot(JS_LANG_Importance);?>',
	Close: '<?php echo quot(JS_LANG_Close);?>',
	Common: '<?php echo quot(JS_LANG_Common);?>',
	EmailAccounts: '<?php echo quot(JS_LANG_EmailAccounts);?>',
	MsgsPerPage: '<?php echo quot(JS_LANG_MsgsPerPage);?>',
	DisableRTE: '<?php echo quot(JS_LANG_DisableRTE);?>',
	Skin: '<?php echo quot(JS_LANG_Skin);?>',
	DefCharset: '<?php echo quot(JS_LANG_DefCharset);?>',
	DefCharsetInc: '<?php echo quot(JS_LANG_DefCharsetInc);?>',
	DefCharsetOut: '<?php echo quot(JS_LANG_DefCharsetOut);?>',
	DefTimeOffset: '<?php echo quot(JS_LANG_DefTimeOffset);?>',
	DefLanguage: '<?php echo quot(JS_LANG_DefLanguage);?>',
	DefDateFormat: '<?php echo quot(JS_LANG_DefDateFormat);?>',
	ShowViewPane: '<?php echo quot(JS_LANG_ShowViewPane);?>',
	Save: '<?php echo quot(JS_LANG_Save);?>',
	Cancel: '<?php echo quot(JS_LANG_Cancel);?>',
	OK: '<?php echo quot(JS_LANG_OK);?>',
	Remove: '<?php echo quot(JS_LANG_Remove);?>',
	AddNewAccount: '<?php echo quot(JS_LANG_AddNewAccount);?>',
	Signature: '<?php echo quot(JS_LANG_Signature);?>',
	Filters: '<?php echo quot(JS_LANG_Filters);?>',
	Properties: '<?php echo quot(JS_LANG_Properties);?>',
	UseForLogin: '<?php echo quot(JS_LANG_UseForLogin);?>',
	MailFriendlyName: '<?php echo quot(JS_LANG_MailFriendlyName);?>',
	MailEmail: '<?php echo quot(JS_LANG_MailEmail);?>',
	MailIncHost: '<?php echo quot(JS_LANG_MailIncHost);?>',
	Imap4: '<?php echo quot(JS_LANG_Imap4);?>',
	Pop3: '<?php echo quot(JS_LANG_Pop3);?>',
	MailIncPort: '<?php echo quot(JS_LANG_MailIncPort);?>',
	MailIncLogin: '<?php echo quot(JS_LANG_MailIncLogin);?>',
	MailIncPass: '<?php echo quot(JS_LANG_MailIncPass);?>',
	MailOutHost: '<?php echo quot(JS_LANG_MailOutHost);?>',
	MailOutPort: '<?php echo quot(JS_LANG_MailOutPort);?>',
	MailOutLogin: '<?php echo quot(JS_LANG_MailOutLogin);?>',
	MailOutPass: '<?php echo quot(JS_LANG_MailOutPass);?>',
	MailOutAuth1: '<?php echo quot(JS_LANG_MailOutAuth1);?>',
	MailOutAuth2: '<?php echo quot(JS_LANG_MailOutAuth2);?>',
	UseFriendlyNm1: '<?php echo quot(JS_LANG_UseFriendlyNm1);?>',
	UseFriendlyNm2: '<?php echo quot(JS_LANG_UseFriendlyNm2);?>',
	GetmailAtLogin: '<?php echo quot(JS_LANG_GetmailAtLogin);?>',
	MailMode0: '<?php echo quot(JS_LANG_MailMode0);?>',
	MailMode1: '<?php echo quot(JS_LANG_MailMode1);?>',
	MailMode2: '<?php echo quot(JS_LANG_MailMode2);?>',
	MailsOnServerDays: '<?php echo quot(JS_LANG_MailsOnServerDays);?>',
	MailMode3: '<?php echo quot(JS_LANG_MailMode3);?>',
	InboxSyncType: '<?php echo quot(JS_LANG_InboxSyncType);?>',
	SyncTypeNo: '<?php echo quot(JS_LANG_SyncTypeNo);?>',
	SyncTypeNewHeaders: '<?php echo quot(JS_LANG_SyncTypeNewHeaders);?>',
	SyncTypeAllHeaders: '<?php echo quot(JS_LANG_SyncTypeAllHeaders);?>',
	SyncTypeNewMessages: '<?php echo quot(JS_LANG_SyncTypeNewMessages);?>',
	SyncTypeAllMessages: '<?php echo quot(JS_LANG_SyncTypeAllMessages);?>',
	SyncTypeDirectMode: '<?php echo quot(JS_LANG_SyncTypeDirectMode);?>',
	Pop3SyncTypeEntireHeaders: '<?php echo quot(JS_LANG_Pop3SyncTypeEntireHeaders);?>',
	Pop3SyncTypeEntireMessages: '<?php echo quot(JS_LANG_Pop3SyncTypeEntireMessages);?>',
	Pop3SyncTypeDirectMode: '<?php echo quot(JS_LANG_Pop3SyncTypeDirectMode);?>',
	DeleteFromDb: '<?php echo quot(JS_LANG_DeleteFromDb);?>',
	EditFilter: '<?php echo quot(JS_LANG_EditFilter);?>',
	NewFilter: '<?php echo quot(JS_LANG_NewFilter);?>',
	Field: '<?php echo quot(JS_LANG_Field);?>',
	Condition: '<?php echo quot(JS_LANG_Condition);?>',
	ContainSubstring: '<?php echo quot(JS_LANG_ContainSubstring);?>',
	ContainExactPhrase: '<?php echo quot(JS_LANG_ContainExactPhrase);?>',
	NotContainSubstring: '<?php echo quot(JS_LANG_NotContainSubstring);?>',
	FilterDesc_At: '<?php echo quot(JS_LANG_FilterDesc_At);?>',
	FilterDesc_Field: '<?php echo quot(JS_LANG_FilterDesc_Field);?>',
	Action: '<?php echo quot(JS_LANG_Action);?>',
	DoNothing: '<?php echo quot(JS_LANG_DoNothing);?>',
	DeleteFromServer: '<?php echo quot(JS_LANG_DeleteFromServer);?>',
	MarkGrey: '<?php echo quot(JS_LANG_MarkGrey);?>',
	Add: '<?php echo quot(JS_LANG_Add);?>',
	OtherFilterSettings: '<?php echo quot(JS_LANG_OtherFilterSettings);?>',
	ConsiderXSpam: '<?php echo quot(JS_LANG_ConsiderXSpam);?>',
	Apply: '<?php echo quot(JS_LANG_Apply);?>',
	InsertLink: '<?php echo quot(JS_LANG_InsertLink);?>',
	RemoveLink: '<?php echo quot(JS_LANG_RemoveLink);?>',
	Numbering: '<?php echo quot(JS_LANG_Numbering);?>',
	Bullets: '<?php echo quot(JS_LANG_Bullets);?>',
	HorizontalLine: '<?php echo quot(JS_LANG_HorizontalLine);?>',
	Bold: '<?php echo quot(JS_LANG_Bold);?>',
	Italic: '<?php echo quot(JS_LANG_Italic);?>',
	Underline: '<?php echo quot(JS_LANG_Underline);?>',
	AlignLeft: '<?php echo quot(JS_LANG_AlignLeft);?>',
	Center: '<?php echo quot(JS_LANG_Center);?>',
	AlignRight: '<?php echo quot(JS_LANG_AlignRight);?>',
	Justify: '<?php echo quot(JS_LANG_Justify);?>',
	FontColor: '<?php echo quot(JS_LANG_FontColor);?>',
	Background: '<?php echo quot(JS_LANG_Background);?>',
	SwitchToPlainMode: '<?php echo quot(JS_LANG_SwitchToPlainMode);?>',
	SwitchToHTMLMode: '<?php echo quot(JS_LANG_SwitchToHTMLMode);?>',
	AddSignatures: '<?php echo quot(JS_LANG_AddSignatures);?>',
	DontAddToReplies: '<?php echo quot(JS_LANG_DontAddToReplies);?>',
	Folder: '<?php echo quot(JS_LANG_Folder);?>',
	Msgs: '<?php echo quot(JS_LANG_Msgs);?>',
	Synchronize: '<?php echo quot(JS_LANG_Synchronize);?>',
	ShowThisFolder: '<?php echo quot(JS_LANG_ShowThisFolder);?>',
	Total: '<?php echo quot(JS_LANG_Total);?>',
	DeleteSelected: '<?php echo quot(JS_LANG_DeleteSelected);?>',
	AddNewFolder: '<?php echo quot(JS_LANG_AddNewFolder);?>',
	NewFolder: '<?php echo quot(JS_LANG_NewFolder);?>',
	ParentFolder: '<?php echo quot(JS_LANG_ParentFolder);?>',
	NoParent: '<?php echo quot(JS_LANG_NoParent);?>',
	OnMailServer: '<?php echo quot(JS_LANG_OnMailServer);?>',
	InWebMail: '<?php echo quot(JS_LANG_InWebMail);?>',
	FolderName: '<?php echo quot(JS_LANG_FolderName);?>',
	ContactsPerPage: '<?php echo quot(JS_LANG_ContactsPerPage);?>',
	WhiteList: '<?php echo quot(JS_LANG_WhiteList);?>',
	CharsetDefault: '<?php echo quot(JS_LANG_CharsetDefault);?>',
	CharsetArabicAlphabetISO: '<?php echo quot(JS_LANG_CharsetArabicAlphabetISO);?>',
	CharsetArabicAlphabet: '<?php echo quot(JS_LANG_CharsetArabicAlphabet);?>',
	CharsetBalticAlphabetISO: '<?php echo quot(JS_LANG_CharsetBalticAlphabetISO);?>',
	CharsetBalticAlphabet: '<?php echo quot(JS_LANG_CharsetBalticAlphabet);?>',
	CharsetCentralEuropeanAlphabetISO: '<?php echo quot(JS_LANG_CharsetCentralEuropeanAlphabetISO);?>',
	CharsetCentralEuropeanAlphabet: '<?php echo quot(JS_LANG_CharsetCentralEuropeanAlphabet);?>',
	CharsetChineseSimplifiedEUC: '<?php echo quot(JS_LANG_CharsetChineseSimplifiedEUC);?>',
	CharsetChineseSimplifiedGB: '<?php echo quot(JS_LANG_CharsetChineseSimplifiedGB);?>',
	CharsetChineseTraditional: '<?php echo quot(JS_LANG_CharsetChineseTraditional);?>',
	CharsetCyrillicAlphabetISO: '<?php echo quot(JS_LANG_CharsetCyrillicAlphabetISO);?>',
	CharsetCyrillicAlphabetKOI8R: '<?php echo quot(JS_LANG_CharsetCyrillicAlphabetKOI8R);?>',
	CharsetCyrillicAlphabet: '<?php echo quot(JS_LANG_CharsetCyrillicAlphabet);?>',
	CharsetGreekAlphabetISO: '<?php echo quot(JS_LANG_CharsetGreekAlphabetISO);?>',
	CharsetGreekAlphabet: '<?php echo quot(JS_LANG_CharsetGreekAlphabet);?>',
	CharsetHebrewAlphabetISO: '<?php echo quot(JS_LANG_CharsetHebrewAlphabetISO);?>',
	CharsetHebrewAlphabet: '<?php echo quot(JS_LANG_CharsetHebrewAlphabet);?>',
	CharsetJapanese: '<?php echo quot(JS_LANG_CharsetJapanese);?>',
	CharsetJapaneseShiftJIS: '<?php echo quot(JS_LANG_CharsetJapaneseShiftJIS);?>',
	CharsetKoreanEUC: '<?php echo quot(JS_LANG_CharsetKoreanEUC);?>',
	CharsetKoreanISO: '<?php echo quot(JS_LANG_CharsetKoreanISO);?>',
	CharsetLatin3AlphabetISO: '<?php echo quot(JS_LANG_CharsetLatin3AlphabetISO);?>',
	CharsetTurkishAlphabet: '<?php echo quot(JS_LANG_CharsetTurkishAlphabet);?>',
	CharsetUniversalAlphabetUTF7: '<?php echo quot(JS_LANG_CharsetUniversalAlphabetUTF7);?>',
	CharsetUniversalAlphabetUTF8: '<?php echo quot(JS_LANG_CharsetUniversalAlphabetUTF8);?>',
	CharsetVietnameseAlphabet: '<?php echo quot(JS_LANG_CharsetVietnameseAlphabet);?>',
	CharsetWesternAlphabetISO: '<?php echo quot(JS_LANG_CharsetWesternAlphabetISO);?>',
	CharsetWesternAlphabet: '<?php echo quot(JS_LANG_CharsetWesternAlphabet);?>',
	TimeDefault: '<?php echo quot(JS_LANG_TimeDefault);?>',
	TimeEniwetok: '<?php echo quot(JS_LANG_TimeEniwetok);?>',
	TimeMidwayIsland: '<?php echo quot(JS_LANG_TimeMidwayIsland);?>',
	TimeHawaii: '<?php echo quot(JS_LANG_TimeHawaii);?>',
	TimeAlaska: '<?php echo quot(JS_LANG_TimeAlaska);?>',
	TimePacific: '<?php echo quot(JS_LANG_TimePacific);?>',
	TimeArizona: '<?php echo quot(JS_LANG_TimeArizona);?>',
	TimeMountain: '<?php echo quot(JS_LANG_TimeMountain);?>',
	TimeCentralAmerica: '<?php echo quot(JS_LANG_TimeCentralAmerica);?>',
	TimeCentral: '<?php echo quot(JS_LANG_TimeCentral);?>',
	TimeMexicoCity: '<?php echo quot(JS_LANG_TimeMexicoCity);?>',
	TimeSaskatchewan: '<?php echo quot(JS_LANG_TimeSaskatchewan);?>',
	TimeIndiana: '<?php echo quot(JS_LANG_TimeIndiana);?>',
	TimeEastern: '<?php echo quot(JS_LANG_TimeEastern);?>',
	TimeBogota: '<?php echo quot(JS_LANG_TimeBogota);?>',
	TimeSantiago: '<?php echo quot(JS_LANG_TimeSantiago);?>',
	TimeCaracas: '<?php echo quot(JS_LANG_TimeCaracas);?>',
	TimeAtlanticCanada: '<?php echo quot(JS_LANG_TimeAtlanticCanada);?>',
	TimeNewfoundland: '<?php echo quot(JS_LANG_TimeNewfoundland);?>',
	TimeGreenland: '<?php echo quot(JS_LANG_TimeGreenland);?>',
	TimeBuenosAires: '<?php echo quot(JS_LANG_TimeBuenosAires);?>',
	TimeBrasilia: '<?php echo quot(JS_LANG_TimeBrasilia);?>',
	TimeMidAtlantic: '<?php echo quot(JS_LANG_TimeMidAtlantic);?>',
	TimeCapeVerde: '<?php echo quot(JS_LANG_TimeCapeVerde);?>',
	TimeAzores: '<?php echo quot(JS_LANG_TimeAzores);?>',
	TimeMonrovia: '<?php echo quot(JS_LANG_TimeMonrovia);?>',
	TimeGMT: '<?php echo quot(JS_LANG_TimeGMT);?>',
	TimeBerlin: '<?php echo quot(JS_LANG_TimeBerlin);?>',
	TimePrague: '<?php echo quot(JS_LANG_TimePrague);?>',
	TimeParis: '<?php echo quot(JS_LANG_TimeParis);?>',
	TimeSarajevo: '<?php echo quot(JS_LANG_TimeSarajevo);?>',
	TimeWestCentralAfrica: '<?php echo quot(JS_LANG_TimeWestCentralAfrica);?>',
	TimeAthens: '<?php echo quot(JS_LANG_TimeAthens);?>',
	TimeEasternEurope: '<?php echo quot(JS_LANG_TimeEasternEurope);?>',
	TimeCairo: '<?php echo quot(JS_LANG_TimeCairo);?>',
	TimeHarare: '<?php echo quot(JS_LANG_TimeHarare);?>',
	TimeHelsinki: '<?php echo quot(JS_LANG_TimeHelsinki);?>',
	TimeIsrael: '<?php echo quot(JS_LANG_TimeIsrael);?>',
	TimeBaghdad: '<?php echo quot(JS_LANG_TimeBaghdad);?>',
	TimeArab: '<?php echo quot(JS_LANG_TimeArab);?>',
	TimeMoscow: '<?php echo quot(JS_LANG_TimeMoscow);?>',
	TimeEastAfrica: '<?php echo quot(JS_LANG_TimeEastAfrica);?>',
	TimeTehran: '<?php echo quot(JS_LANG_TimeTehran);?>',
	TimeAbuDhabi: '<?php echo quot(JS_LANG_TimeAbuDhabi);?>',
	TimeCaucasus: '<?php echo quot(JS_LANG_TimeCaucasus);?>',
	TimeKabul: '<?php echo quot(JS_LANG_TimeKabul);?>',
	TimeEkaterinburg: '<?php echo quot(JS_LANG_TimeEkaterinburg);?>',
	TimeIslamabad: '<?php echo quot(JS_LANG_TimeIslamabad);?>',
	TimeBombay: '<?php echo quot(JS_LANG_TimeBombay);?>',
	TimeNepal: '<?php echo quot(JS_LANG_TimeNepal);?>',
	TimeAlmaty: '<?php echo quot(JS_LANG_TimeAlmaty);?>',
	TimeDhaka: '<?php echo quot(JS_LANG_TimeDhaka);?>',
	TimeSriLanka: '<?php echo quot(JS_LANG_TimeSriLanka);?>',
	TimeRangoon: '<?php echo quot(JS_LANG_TimeRangoon);?>',
	TimeBangkok: '<?php echo quot(JS_LANG_TimeBangkok);?>',
	TimeKrasnoyarsk: '<?php echo quot(JS_LANG_TimeKrasnoyarsk);?>',
	TimeBeijing: '<?php echo quot(JS_LANG_TimeBeijing);?>',
	TimeIrkutsk: '<?php echo quot(JS_LANG_TimeIrkutsk);?>',
	TimeSingapore: '<?php echo quot(JS_LANG_TimeSingapore);?>',
	TimePerth: '<?php echo quot(JS_LANG_TimePerth);?>',
	TimeTaipei: '<?php echo quot(JS_LANG_TimeTaipei);?>',
	TimeTokyo: '<?php echo quot(JS_LANG_TimeTokyo);?>',
	TimeSeoul: '<?php echo quot(JS_LANG_TimeSeoul);?>',
	TimeYakutsk: '<?php echo quot(JS_LANG_TimeYakutsk);?>',
	TimeAdelaide: '<?php echo quot(JS_LANG_TimeAdelaide);?>',
	TimeDarwin: '<?php echo quot(JS_LANG_TimeDarwin);?>',
	TimeBrisbane: '<?php echo quot(JS_LANG_TimeBrisbane);?>',
	TimeSydney: '<?php echo quot(JS_LANG_TimeSydney);?>',
	TimeGuam: '<?php echo quot(JS_LANG_TimeGuam);?>',
	TimeHobart: '<?php echo quot(JS_LANG_TimeHobart);?>',
	TimeVladivostock: '<?php echo quot(JS_LANG_TimeVladivostock);?>',
	TimeMagadan: '<?php echo quot(JS_LANG_TimeMagadan);?>',
	TimeWellington: '<?php echo quot(JS_LANG_TimeWellington);?>',
	TimeFiji: '<?php echo quot(JS_LANG_TimeFiji);?>',
	TimeTonga: '<?php echo quot(JS_LANG_TimeTonga);?>',
	DateDefault: '<?php echo quot(JS_LANG_DateDefault);?>',
	DateDDMMYY: '<?php echo quot(JS_LANG_DateDDMMYY);?>',
	DateMMDDYY: '<?php echo quot(JS_LANG_DateMMDDYY);?>',
	DateDDMonth: '<?php echo quot(JS_LANG_DateDDMonth);?>',
	DateAdvanced: '<?php echo quot(JS_LANG_DateAdvanced);?>',
	NewContact: '<?php echo quot(JS_LANG_NewContact);?>',
	NewGroup: '<?php echo quot(JS_LANG_NewGroup);?>',
	AddContactsTo: '<?php echo quot(JS_LANG_AddContactsTo);?>',
	ImportContacts: '<?php echo quot(JS_LANG_ImportContacts);?>',
	Name: '<?php echo quot(JS_LANG_Name);?>',
	Email: '<?php echo quot(JS_LANG_Email);?>',
	DefaultEmail: '<?php echo quot(JS_LANG_DefaultEmail);?>',
	NotSpecifiedYet: '<?php echo quot(JS_LANG_NotSpecifiedYet);?>',
	ContactName: '<?php echo quot(JS_LANG_ContactName);?>',
	Birthday: '<?php echo quot(JS_LANG_Birthday);?>',
	Month: '<?php echo quot(JS_LANG_Month);?>',
	January: '<?php echo quot(JS_LANG_January);?>',
	February: '<?php echo quot(JS_LANG_February);?>',
	March: '<?php echo quot(JS_LANG_March);?>',
	April: '<?php echo quot(JS_LANG_April);?>',
	May: '<?php echo quot(JS_LANG_May);?>',
	June: '<?php echo quot(JS_LANG_June);?>',
	July: '<?php echo quot(JS_LANG_July);?>',
	August: '<?php echo quot(JS_LANG_August);?>',
	September: '<?php echo quot(JS_LANG_September);?>',
	October: '<?php echo quot(JS_LANG_October);?>',
	November: '<?php echo quot(JS_LANG_November);?>',
	December: '<?php echo quot(JS_LANG_December);?>',
	Day: '<?php echo quot(JS_LANG_Day);?>',
	Year: '<?php echo quot(JS_LANG_Year);?>',
	UseFriendlyName1: '<?php echo quot(JS_LANG_UseFriendlyName1);?>',
	UseFriendlyName2: '<?php echo quot(JS_LANG_UseFriendlyName2);?>',
	Personal: '<?php echo quot(JS_LANG_Personal);?>',
	PersonalEmail: '<?php echo quot(JS_LANG_PersonalEmail);?>',
	StreetAddress: '<?php echo quot(JS_LANG_StreetAddress);?>',
	City: '<?php echo quot(JS_LANG_City);?>',
	Fax: '<?php echo quot(JS_LANG_Fax);?>',
	StateProvince: '<?php echo quot(JS_LANG_StateProvince);?>',
	Phone: '<?php echo quot(JS_LANG_Phone);?>',
	ZipCode: '<?php echo quot(JS_LANG_ZipCode);?>',
	Mobile: '<?php echo quot(JS_LANG_Mobile);?>',
	CountryRegion: '<?php echo quot(JS_LANG_CountryRegion);?>',
	WebPage: '<?php echo quot(JS_LANG_WebPage);?>',
	Go: '<?php echo quot(JS_LANG_Go);?>',
	Home: '<?php echo quot(JS_LANG_Home);?>',
	Business: '<?php echo quot(JS_LANG_Business);?>',
	BusinessEmail: '<?php echo quot(JS_LANG_BusinessEmail);?>',
	Company: '<?php echo quot(JS_LANG_Company);?>',
	JobTitle: '<?php echo quot(JS_LANG_JobTitle);?>',
	Department: '<?php echo quot(JS_LANG_Department);?>',
	Office: '<?php echo quot(JS_LANG_Office);?>',
	Pager: '<?php echo quot(JS_LANG_Pager);?>',
	Other: '<?php echo quot(JS_LANG_Other);?>',
	OtherEmail: '<?php echo quot(JS_LANG_OtherEmail);?>',
	Notes: '<?php echo quot(JS_LANG_Notes);?>',
	Groups: '<?php echo quot(JS_LANG_Groups);?>',
	ShowAddFields: '<?php echo quot(JS_LANG_ShowAddFields);?>',
	HideAddFields: '<?php echo quot(JS_LANG_HideAddFields);?>',
	EditContact: '<?php echo quot(JS_LANG_EditContact);?>',
	GroupName: '<?php echo quot(JS_LANG_GroupName);?>',
	AddContacts: '<?php echo quot(JS_LANG_AddContacts);?>',
	CommentAddContacts: '<?php echo quot(JS_LANG_CommentAddContacts);?>',
	CreateGroup: '<?php echo quot(JS_LANG_CreateGroup);?>',
	Rename: '<?php echo quot(JS_LANG_Rename);?>',
	MailGroup: '<?php echo quot(JS_LANG_MailGroup);?>',
	RemoveFromGroup: '<?php echo quot(JS_LANG_RemoveFromGroup);?>',
	UseImportTo: '<?php echo quot(JS_LANG_UseImportTo);?>',
	Outlook1: '<?php echo quot(JS_LANG_Outlook1);?>',
	Outlook2: '<?php echo quot(JS_LANG_Outlook2);?>',
	SelectImportFile: '<?php echo quot(JS_LANG_SelectImportFile);?>',
	Import: '<?php echo quot(JS_LANG_Import);?>',
	ContactsMessage: '<?php echo quot(JS_LANG_ContactsMessage);?>',
	ContactsCount: '<?php echo quot(JS_LANG_ContactsCount);?>',
	GroupsCount: '<?php echo quot(JS_LANG_GroupsCount);?>',

	InfoListNotContainAddress: '<?php echo quot(InfoListNotContainAddress);?>',

	PicturesBlocked: '<?php echo quot(PicturesBlocked);?>',
	ShowPictures: '<?php echo quot(ShowPictures);?>',
	ShowPicturesFromSender: '<?php echo quot(ShowPicturesFromSender);?>',
	AlwaysShowPictures: '<?php echo quot(AlwaysShowPictures);?>',

	DirectAccess: '<?php echo quot(DirectAccess);?>',
	DirectAccessTitle: '<?php echo quot(DirectAccessTitle);?>',

	ReportMessageSent: '<?php echo quot(ReportMessageSent);?>',
	ReportMessageSaved: '<?php echo quot(ReportMessageSaved);?>',

	ReportSettingsUpdatedSuccessfuly: '<?php echo quot(ReportSettingsUpdatedSuccessfuly);?>',
	ReportAccountCreatedSuccessfuly: '<?php echo quot(ReportAccountCreatedSuccessfuly);?>',
	ReportAccountUpdatedSuccessfuly: '<?php echo quot(ReportAccountUpdatedSuccessfuly);?>',
	ConfirmDeleteAccount: '<?php echo quot(ConfirmDeleteAccount);?>',
	ReportFiltersUpdatedSuccessfuly: '<?php echo quot(ReportFiltersUpdatedSuccessfuly);?>',
	ReportSignatureUpdatedSuccessfuly: '<?php echo quot(ReportSignatureUpdatedSuccessfuly);?>',
	ReportFoldersUpdatedSuccessfuly: '<?php echo quot(ReportFoldersUpdatedSuccessfuly);?>',
	ReportContactsSettingsUpdatedSuccessfuly: '<?php echo quot(ReportContactsSettingsUpdatedSuccessfuly);?>',

	ReportGroupSuccessfulyAdded1: '<?php echo quot(ReportGroupSuccessfulyAdded1);?>',
	ReportGroupSuccessfulyAdded2: '<?php echo quot(ReportGroupSuccessfulyAdded2);?>',
	ReportGroupUpdatedSuccessfuly: '<?php echo quot(ReportGroupUpdatedSuccessfuly);?>',
	ReportContactSuccessfulyAdded: '<?php echo quot(ReportContactSuccessfulyAdded);?>',
	ReportContactUpdatedSuccessfuly: '<?php echo quot(ReportContactUpdatedSuccessfuly);?>',
	ReportContactAddedToGroup: '<?php echo quot(ReportContactAddedToGroup);?>',
	AlertNoContactsGroupsSelected: '<?php echo quot(AlertNoContactsGroupsSelected);?>',

	TreatAsOrganization: '<?php echo quot(TreatAsOrganization);?>',
	Organization: '<?php echo quot(Organization);?>',
	
	ErrorInvalidCSV: '<?php echo quot(ErrorInvalidCSV);?>',

	WarningPassBlank: '<?php echo quot(WarningPassBlank);?>',
	WarningCorrectIncServer: '<?php echo quot(WarningCorrectIncServer);?>',
	WarningOutServerBlank: '<?php echo quot(WarningOutServerBlank);?>',
	WarningCorrectSMTPServer: '<?php echo quot(WarningCorrectSMTPServer);?>',
	WarningFromBlank: '<?php echo quot(WarningFromBlank);?>',
	WarningAdvancedDateFormat: '<?php echo quot(WarningAdvancedDateFormat);?>',
	WarningCorrectFolderName: '<?php echo quot(WarningCorrectFolderName);?>',
	WarningLoginFieldBlank: '<?php echo quot(WarningLoginFieldBlank);?>',

	InfoNoMessagesFound: '<?php echo quot(InfoNoMessagesFound);?>',

	FolderInbox: '<?php echo quot(FolderInbox);?>',
	FolderSentItems: '<?php echo quot(FolderSentItems);?>',
	FolderDrafts: '<?php echo quot(FolderDrafts);?>',
	FolderTrash: '<?php echo quot(FolderTrash);?>',

	BackToList: '<?php echo quot(BackToList);?>',
	InfoNoContactsGroups: '<?php echo quot(InfoNoContactsGroups);?>',
	InfoNewContactsGroups: '<?php echo quot(InfoNewContactsGroups);?>',
	DefTimeFormat: '<?php echo quot(DefTimeFormat);?>',
	SpellNoSuggestions: '<?php echo quot(SpellNoSuggestions); ?>',
	SpellWait: '<?php echo quot(SpellWait); ?>',
	
	InfoNoMessageSelected: '<?php echo quot(InfoNoMessageSelected); ?>',
	InfoSingleDoubleClick: '<?php echo quot(InfoSingleDoubleClick); ?>',

	Calendar: '<?php echo quot(Calendar); ?>',
	SettingsTabCalendar: '<?php echo quot(SettingsTabCalendar); ?>',

	TabDay: '<?php echo quot(TabDay);?>',
	TabWeek: '<?php echo quot(TabWeek);?>',
	TabMonth: '<?php echo quot(TabMonth);?>',

	FullDayMonday: '<?php echo quot(FullDayMonday);?>',
	FullDayTuesday: '<?php echo quot(FullDayTuesday);?>',
	FullDayWednesday: '<?php echo quot(FullDayWednesday);?>',
	FullDayThursday: '<?php echo quot(FullDayThursday);?>',
	FullDayFriday: '<?php echo quot(FullDayFriday);?>',
	FullDaySaturday: '<?php echo quot(FullDaySaturday);?>',
	FullDaySunday: '<?php echo quot(FullDaySunday);?>',
	
	ShortMonthJanuary: '<?php echo quot(ShortMonthJanuary);?>',
	ShortMonthFebruary: '<?php echo quot(ShortMonthFebruary);?>',
	ShortMonthMarch: '<?php echo quot(ShortMonthMarch);?>',
	ShortMonthApril: '<?php echo quot(ShortMonthApril);?>',
	ShortMonthMay: '<?php echo quot(ShortMonthMay);?>',
	ShortMonthJune: '<?php echo quot(ShortMonthJune);?>',
	ShortMonthJuly: '<?php echo quot(ShortMonthJuly);?>',
	ShortMonthAugust: '<?php echo quot(ShortMonthAugust);?>',
	ShortMonthSeptember: '<?php echo quot(ShortMonthSeptember);?>',
	ShortMonthOctober: '<?php echo quot(ShortMonthOctober);?>',
	ShortMonthNovember: '<?php echo quot(ShortMonthNovember);?>',
	ShortMonthDecember: '<?php echo quot(ShortMonthDecember);?>',

	InfoLoading: '<?php echo quot(InfoLoading);?>',
	InfoSaving: '<?php echo quot(InfoSaving);?>',
	SettingsDisplayName: '<?php echo quot(SettingsDisplayName);?>',
	SettingsTimeFormat: '<?php echo quot(SettingsTimeFormat);?>',
	SettingsDateFormat: '<?php echo quot(SettingsDateFormat);?>',
	SettingsShowWeekends: '<?php echo quot(SettingsShowWeekends);?>',
	SettingsWorkdayStarts: '<?php echo quot(SettingsWorkdayStarts);?>',
	SettingsWorkdayEnds: '<?php echo quot(SettingsWorkdayEnds);?>',
	SettingsShowWorkday: '<?php echo quot(SettingsShowWorkday);?>',
	SettingsWeekStartsOn: '<?php echo quot(SettingsWeekStartsOn);?>',
	SettingsDefaultTab: '<?php echo quot(SettingsDefaultTab);?>',
	SettingsCountry: '<?php echo quot(SettingsCountry);?>',
	SettingsTimeZone: '<?php echo quot(SettingsTimeZone);?>',
	SettingsAllTimeZones: '<?php echo quot(SettingsAllTimeZones);?>',

	ButtonCancel: '<?php echo quot(ButtonCancel);?>',
	ButtonSave: '<?php echo quot(ButtonSave);?>',
	
	WarningWorkdayStartsEnds: '<?php echo quot(WarningWorkdayStartsEnds);?>',
	ReportSettingsUpdated: '<?php echo quot(ReportSettingsUpdated);?>',
	
	SettingsTabCalendar: '<?php echo quot(SettingsTabCalendar);?>',
	
	ErrorParseJSON: '<?php echo quot(ErrorParseJSON);?>',
	ErrorGeneral: '<?php echo quot(ErrorGeneral);?>',
	
	ShortMonthJanuary: '<?php echo quot(ShortMonthJanuary);?>',
	ShortMonthFebruary: '<?php echo quot(ShortMonthFebruary);?>',
	ShortMonthMarch: '<?php echo quot(ShortMonthMarch);?>',
	ShortMonthApril: '<?php echo quot(ShortMonthApril);?>',
	ShortMonthMay: '<?php echo quot(ShortMonthMay);?>',
	ShortMonthJune: '<?php echo quot(ShortMonthJune);?>',
	ShortMonthJuly: '<?php echo quot(ShortMonthJuly);?>',
	ShortMonthAugust: '<?php echo quot(ShortMonthAugust);?>',
	ShortMonthSeptember: '<?php echo quot(ShortMonthSeptember);?>',
	ShortMonthOctober: '<?php echo quot(ShortMonthOctober);?>',
	ShortMonthNovember: '<?php echo quot(ShortMonthNovember);?>',
	ShortMonthDecember: '<?php echo quot(ShortMonthDecember);?>',
	
	GroupMembers: '<?php echo quot(GroupMembers);?>',
	Attachments: '<?php echo quot(Attachments);?>',
	InfoGroupsOfContact: '<?php echo quot(InfoGroupsOfContact);?>',
	AlertNoContactsSelected: '<?php echo quot(AlertNoContactsSelected);?>',
	MailSelected: '<?php echo quot(MailSelected);?>',
	CaptionSubscribed: '<?php echo quot(CaptionSubscribed);?>',
	OperationSpam: '<?php echo quot(OperationSpam);?>',
	OperationNotSpam: '<?php echo quot(OperationNotSpam);?>',
	FolderSpam: '<?php echo quot(FolderSpam);?>',

	ContactMail: '<?php echo quot(ContactMail);?>',
	ContactViewAllMails: '<?php echo quot(ContactViewAllMails);?>',
	ContactsMailThem: '<?php echo quot(ContactsMailThem);?>',
	DateToday: '<?php echo quot(DateToday);?>',
	DateYesterday: '<?php echo quot(DateYesterday);?>',
	MessageShowDetails: '<?php echo quot(MessageShowDetails);?>',
	MessageHideDetails: '<?php echo quot(MessageHideDetails);?>',
	MessageNoSubject: '<?php echo quot(MessageNoSubject);?>',
	MessageForAddr: '<?php echo quot(MessageForAddr);?>',
	SearchClear: '<?php echo quot(SearchClear);?>',
	SearchResultsInFolder: '<?php echo quot(SearchResultsInFolder);?>',
	SearchResultsInAllFolders: '<?php echo quot(SearchResultsInAllFolders);?>',
	AutoresponderTitle: '<?php echo quot(AutoresponderTitle);?>',
	AutoresponderEnable: '<?php echo quot(AutoresponderEnable);?>',
	AutoresponderSubject: '<?php echo quot(AutoresponderSubject);?>',
	AutoresponderMessage: '<?php echo quot(AutoresponderMessage);?>',
	ReportAutoresponderUpdatedSuccessfuly: '<?php echo quot(ReportAutoresponderUpdatedSuccessfuly);?>',
	FolderQuarantine: '<?php echo quot(FolderQuarantine);?>',

	WarningInputCorrectEmails: '<?php echo quot(WarningInputCorrectEmails);?>',
	WrongEmails: '<?php echo quot(WrongEmails);?>',

	ConfirmBodySize1: '<?php echo quot(ConfirmBodySize1);?>',
	ConfirmBodySize2: '<?php echo quot(ConfirmBodySize2);?>',
	BodySizeCounter: '<?php echo quot(BodySizeCounter);?>',
	InsertImage: '<?php echo quot(InsertImage);?>',
	ImagePath: '<?php echo quot(ImagePath);?>',
	ImageUpload: '<?php echo quot(ImageUpload);?>',
    WarningImageUpload: '<?php echo quot(WarningImageUpload);?>',

    ConfirmExitFromNewMessage: '<?php echo quot(ConfirmExitFromNewMessage);?>',

    MessageSizeExceedsAccountQuota: '<?php echo quot(MessageSizeExceedsAccountQuota);?>',
    MessageCannotSent: '<?php echo quot(MessageCannotSent);?>',
    MessageCannotSaved: '<?php echo quot(MessageCannotSaved);?>',

<?php

if (isset($GLOBALS['LangNamesArray']) && is_array($GLOBALS['LangNamesArray']))
{
	$_tmp =& $GLOBALS['LangNamesArray'];
	foreach ($_tmp as $name => $localname)
	{
		echo '	Language'.quot($name).': \''.quot($localname).'\','."\r\n";
	}
}

?>

	Spellcheck: '<?php echo quot(Spellcheck);?>',
	
	EmptySpam: '<?php echo quot(EmptySpam);?>',
	Saving: '<?php echo quot(Saving);?>',
	Sending: '<?php echo quot(Sending);?>',
	
	LANG_Email: '<?php echo quot(LANG_Email);?>',
	LANG_Login: '<?php echo quot(LANG_Login);?>',
	LANG_Password: '<?php echo quot(LANG_Password);?>',
	LANG_IncServer: '<?php echo quot(LANG_IncServer);?>',
    LANG_IncPort: '<?php echo quot(LANG_IncPort);?>',
    LANG_OutServer: '<?php echo quot(LANG_OutServer);?>',
    LANG_OutPort: '<?php echo quot(LANG_OutPort);?>',
    LANG_UseSmtpAuth: '<?php echo quot(LANG_UseSmtpAuth);?>',
    LANG_SignMe: '<?php echo quot(LANG_SignMe);?>',
    LANG_Enter: '<?php echo quot(LANG_Enter);?>',
    LANG_LoginInfo: '<?php echo quot(LANG_LoginInfo);?>',

	RepliedMessageTitle: '<?php echo quot(RepliedMessageTitle);?>',
	ForwardedMessageTitle: '<?php echo quot(ForwardedMessageTitle);?>',
	RepliedForwardedMessageTitle: '<?php echo quot(RepliedForwardedMessageTitle);?>',

	RequestReadConfirmation: '<?php echo quot(RequestReadConfirmation);?>',
	FolderTypeDefault: '<?php echo quot(FolderTypeDefault);?>',
	ShowFoldersMapping: '<?php echo quot(ShowFoldersMapping);?>',
	ShowFoldersMappingNote: '<?php echo quot(ShowFoldersMappingNote);?>',
	FolderTypeMapTo: '<?php echo quot(FolderTypeMapTo);?>',
	
	AccountNewPassword: '<?php echo quot(AccountNewPassword);?>',
	AccountConfirmNewPassword: '<?php echo quot(AccountConfirmNewPassword);?>',
	AccountPasswordsDoNotMatch: '<?php echo quot(AccountPasswordsDoNotMatch);?>',
	
	ContactTitle: '<?php echo quot(ContactTitle);?>',
	ContactFirstName: '<?php echo quot(ContactFirstName);?>',
	ContactSurName: '<?php echo quot(ContactSurName);?>',
	ContactNickName: '<?php echo quot(ContactNickName);?>',

	CaptchaTitle: '<?php echo quot(CaptchaTitle);?>',
	CaptchaReloadLink: '<?php echo quot(CaptchaReloadLink);?>',

	ConfirmBodySize1: '<?php echo quot(ConfirmBodySize1); ?>',
	ConfirmBodySize2: '<?php echo quot(ConfirmBodySize2); ?>',
	BodySizeCounter: '<?php echo quot(BodySizeCounter); ?>',
	InsertImage: '<?php echo quot(InsertImage); ?>',
	ImagePath: '<?php echo quot(ImagePath); ?>',
	ImageUpload: '<?php echo quot(ImageUpload); ?>',

	SensivityMenu: '<?php echo quot(SensivityMenu); ?>',
	SensivityNothingMenu: '<?php echo quot(SensivityNothingMenu); ?>',
	SensivityConfidentialMenu: '<?php echo quot(SensivityConfidentialMenu); ?>',
	SensivityPrivateMenu: '<?php echo quot(SensivityPrivateMenu); ?>',
	SensivityPersonalMenu: '<?php echo quot(SensivityPersonalMenu); ?>',

	SensivityConfidential: '<?php echo quot(SensivityConfidential);?>',
	SensivityPrivate: '<?php echo quot(SensivityPrivate);?>',
	SensivityPersonal: '<?php echo quot(SensivityPersonal);?>',

	ReturnReceiptTopText: '<?php echo quot(ReturnReceiptTopText);?>',
	ReturnReceiptTopLink: '<?php echo quot(ReturnReceiptTopLink);?>',
	ReturnReceiptSubject: '<?php echo quot(ReturnReceiptSubject);?>',
	ReturnReceiptMailText1: '<?php echo quot(ReturnReceiptMailText1);?>',
	ReturnReceiptMailText2: '<?php echo quot(ReturnReceiptMailText2);?>',

	ContactFieldTitle: '<?php echo quot(ContactFieldTitle);?>',
	ContactDropDownTO: '<?php echo quot(ContactDropDownTO);?>',
	ContactDropDownCC: '<?php echo quot(ContactDropDownCC);?>',
	ContactDropDownBCC: '<?php echo quot(ContactDropDownBCC);?>',

	WebMailException: '<?php echo quot(WebMailException);?>',

	NoMoveDelete: '<?php echo quot(NoMoveDelete);?>',
	WarningFieldBlank: '<?php echo quot(WarningFieldBlank);?>',
	WarningPassNotMatch: '<?php echo quot(WarningPassNotMatch);?>',
	PasswordResetTitle: '<?php echo quot(PasswordResetTitle);?>',
	NullUserNameonReset: '<?php echo quot(NullUserNameonReset);?>',
	IndexResetLink: '<?php echo quot(IndexResetLink);?>',
	IndexRegLink: '<?php echo quot(IndexRegLink);?>',

	RegRegistrationTitle: '<?php echo quot(RegRegistrationTitle);?>',
	RegName: '<?php echo quot(RegName);?>',
	RegEmail: '<?php echo quot(RegEmail);?>',
	RegEmailDesc: '<?php echo quot(RegEmailDesc);?>',
	RegSignMe: '<?php echo quot(RegSignMe);?>',
	RegSignMeDesc: '<?php echo quot(RegSignMeDesc);?>',
	RegPass1: '<?php echo quot(RegPass1);?>',
	RegPass2: '<?php echo quot(RegPass2);?>',
	RegQuestionDesc: '<?php echo quot(RegQuestionDesc);?>',
	RegQuestion1: '<?php echo quot(RegQuestion1);?>',
	RegAnswer1: '<?php echo quot(RegAnswer1);?>',
	RegQuestion2: '<?php echo quot(RegQuestion2);?>',
	RegAnswer2: '<?php echo quot(RegAnswer2);?>',
	RegTimeZone: '<?php echo quot(RegTimeZone);?>',
	RegLang: '<?php echo quot(RegLang);?>',
	RegCaptcha: '<?php echo quot(RegCaptcha);?>',
	RegSubmitButtonValue: '<?php echo quot(RegSubmitButtonValue);?>',

	ResetEmail: '<?php echo quot(ResetEmail);?>',
	ResetEmailDesc: '<?php echo quot(ResetEmailDesc);?>',
	ResetCaptcha: '<?php echo quot(ResetCaptcha);?>',
	ResetSubmitStep1: '<?php echo quot(ResetSubmitStep1);?>',
	ResetTopDesc1Step2: '<?php echo quot(ResetTopDesc1Step2);?>',
	ResetTopDesc2Step2: '<?php echo quot(ResetTopDesc2Step2);?>',
	ResetQuestion1: '<?php echo quot(ResetQuestion1);?>',
	ResetAnswer1: '<?php echo quot(ResetAnswer1);?>',
	ResetQuestion2: '<?php echo quot(ResetQuestion2);?>',
	ResetAnswer2: '<?php echo quot(ResetAnswer2);?>',
	ResetSubmitStep2: '<?php echo quot(ResetSubmitStep2);?>',
	ResetTopDescStep3: '<?php echo quot(ResetTopDescStep3);?>',
	ResetPass1: '<?php echo quot(ResetPass1);?>',
	ResetPass2: '<?php echo quot(ResetPass2);?>',
	ResetSubmitStep3: '<?php echo quot(ResetSubmitStep3);?>',
	ResetDescStep4: '<?php echo quot(ResetDescStep4);?>',
	ResetSubmitStep4: '<?php echo quot(ResetSubmitStep4);?>',
	RegReturnLink: '<?php echo quot(RegReturnLink);?>',
	ResetReturnLink: '<?php echo quot(ResetReturnLink);?>',

	SettingsAutoAddInvitation: '<?php echo quot(SettingsAutoAddInvitation);?>',

	FilterPhrase: '<?php echo quot(FilterPhrase);?>',
	FiltersAdd: '<?php echo quot(FiltersAdd);?>',
	FiltersCondEqualTo: '<?php echo quot(FiltersCondEqualTo);?>',
	FiltersCondContainSubstr: '<?php echo quot(FiltersCondContainSubstr);?>',
	FiltersCondNotContainSubstr: '<?php echo quot(FiltersCondNotContainSubstr);?>',
	FiltersActionDelete: '<?php echo quot(FiltersActionDelete);?>',
	FiltersActionMove: '<?php echo quot(FiltersActionMove);?>',
	FiltersActionToFolder: '<?php echo quot(FiltersActionToFolder);?>',
	FiltersNo: '<?php echo quot(FiltersNo);?>',
	FiltersLoading: '<?php echo quot(FiltersLoading);?>',
	ConfirmMessagesPermanentlyDeleted: '<?php echo quot(ConfirmMessagesPermanentlyDeleted);?>',

	AutoCheckMailIntervalLabel: '<?php echo quot(AutoCheckMailIntervalLabel);?>',
	AutoCheckMailIntervalDisableName: '<?php echo quot(AutoCheckMailIntervalDisableName);?>',

	InfoNoNewMessages: '<?php echo quot(InfoNoNewMessages);?>',
	TitleImportContacts: '<?php echo quot(TitleImportContacts);?>',
	TitleSelectedContacts: '<?php echo quot(TitleSelectedContacts);?>',
	TitleNewContact: '<?php echo quot(TitleNewContact);?>',
	TitleViewContact: '<?php echo quot(TitleViewContact);?>',
	TitleEditContact: '<?php echo quot(TitleEditContact);?>',
	TitleNewGroup: '<?php echo quot(TitleNewGroup);?>',
	TitleViewGroup: '<?php echo quot(TitleViewGroup);?>',
	
	AttachmentPending: '<?php echo quot(AttachmentPending);?>',
	AttachmentUploading: '<?php echo quot(AttachmentUploading);?>',
	AttachmentComplete: '<?php echo quot(AttachmentComplete);?>',
	AttachmentCancelled: '<?php echo quot(AttachmentCancelled);?>',
	AttachmentStopped: '<?php echo quot(AttachmentStopped);?>',
	AttachmentsUpload: '<?php echo quot(AttachmentsUpload);?>',
	AttachmentsUploadPadding: <?php echo quot(AttachmentsUploadPadding);?>,

	ReportContactSyncDone: '<?php echo quot(ReportContactSyncDone);?>',
	MobileSyncUrlTitle: '<?php echo quot(MobileSyncUrlTitle);?>',
	MobileSyncLoginTitle: '<?php echo quot(MobileSyncLoginTitle);?>',
	MobileSyncContactDataBaseTitle: '<?php echo quot(MobileSyncContactDataBaseTitle);?>',
	MobileSyncCalendarDataBaseTitle: '<?php echo quot(MobileSyncCalendarDataBaseTitle);?>',
	MobileSyncTitleText: '<?php echo quot(MobileSyncTitleText);?>',
	MobileSyncEnableLabel: '<?php echo quot(MobileSyncEnableLabel);?>',

	QuickReply: '<?php echo quot(QuickReply);?>',
	SwitchToFullForm: '<?php echo quot(SwitchToFullForm);?>',
	SortFieldDate: '<?php echo quot(SortFieldDate);?>',
	SortFieldFrom: '<?php echo quot(SortFieldFrom);?>',
	SortFieldSize: '<?php echo quot(SortFieldSize);?>',
	SortFieldSubject: '<?php echo quot(SortFieldSubject);?>',
	SortFieldFlag: '<?php echo quot(SortFieldFlag);?>',
	SortFieldAttachments: '<?php echo quot(SortFieldAttachments);?>',
	SortOrderAscending: '<?php echo quot(SortOrderAscending);?>',
	SortOrderDescending: '<?php echo quot(SortOrderDescending);?>',
	ArrangedBy: '<?php echo quot(ArrangedBy);?>',

	MessagePaneToRight: '<?php echo quot(MessagePaneToRight);?>',
    SettingsTabMobileSync: '<?php echo quot(SettingsTabMobileSync);?>',

    SearchInputText: '<?php echo quot(SearchInputText);?>',
    UnknownUploadError: '<?php echo quot(UnknownUploadError);?>',

    Searching: '<?php echo quot(Searching);?>',
    SaveMailInSentItems: '<?php echo quot(SaveMailInSentItems);?>',

	TestButton: '<?php echo quot(TestButton);?>',
    NullLang: 'Null'
};

var $Monthes = [];
$Monthes[0]  = Lang.Month;
$Monthes[1]  = Lang.January;
$Monthes[2]  = Lang.February;
$Monthes[3]  = Lang.March;
$Monthes[4]  = Lang.April;
$Monthes[5]  = Lang.May;
$Monthes[6]  = Lang.June;
$Monthes[7]  = Lang.July;
$Monthes[8]  = Lang.August;
$Monthes[9]  = Lang.September;
$Monthes[10] = Lang.October;
$Monthes[11] = Lang.November;
$Monthes[12] = Lang.December;
Lang.Monthes = $Monthes;

var Charsets = [
	{ Name: Lang.CharsetDefault, Value: '0' },
	{ Name: Lang.CharsetArabicAlphabetISO, Value: '28596' },
	{ Name: Lang.CharsetArabicAlphabet, Value: '1256' },
	{ Name: Lang.CharsetBalticAlphabetISO, Value: '28594' },
	{ Name: Lang.CharsetBalticAlphabet, Value: '1257' },
	{ Name: Lang.CharsetCentralEuropeanAlphabetISO, Value: '28592' },
	{ Name: Lang.CharsetCentralEuropeanAlphabet, Value: '1250' },
	{ Name: Lang.CharsetChineseSimplifiedEUC, Value: '51936' },
	{ Name: Lang.CharsetChineseSimplifiedGB, Value: '936' },
	{ Name: Lang.CharsetChineseTraditional, Value: '950' },
	{ Name: Lang.CharsetCyrillicAlphabetISO, Value: '28595' },
	{ Name: Lang.CharsetCyrillicAlphabetKOI8R, Value: '20866' },
	{ Name: Lang.CharsetCyrillicAlphabet, Value: '1251' },
	{ Name: Lang.CharsetGreekAlphabetISO, Value: '28597' },
	{ Name: Lang.CharsetGreekAlphabet, Value: '1253' },
	{ Name: Lang.CharsetHebrewAlphabetISO, Value: '28598' },
	{ Name: Lang.CharsetHebrewAlphabet, Value: '1255' },
	{ Name: Lang.CharsetJapanese, Value: '50220' },
	{ Name: Lang.CharsetJapaneseShiftJIS, Value: '932' },
	{ Name: Lang.CharsetKoreanEUC, Value: '949' },
	{ Name: Lang.CharsetKoreanISO, Value: '50225' },
	{ Name: Lang.CharsetLatin3AlphabetISO, Value: '28593' },
	{ Name: Lang.CharsetTurkishAlphabet, Value: '1254' },
	{ Name: Lang.CharsetUniversalAlphabetUTF7, Value: '65000' },
	{ Name: Lang.CharsetUniversalAlphabetUTF8, Value: '65001' },
	{ Name: Lang.CharsetVietnameseAlphabet, Value: '1258'},
	{ Name: Lang.CharsetWesternAlphabetISO, Value: '28591' },
	{ Name: Lang.CharsetWesternAlphabet, Value: '1252' }
];

var TimeOffsets = [
	{ Name: Lang.TimeDefault, Value: '0' },
	{ Name: '(GMT -12:00) ' + Lang.TimeEniwetok, Value: '1' },
	{ Name: '(GMT -11:00) ' + Lang.TimeMidwayIsland, Value: '2' },
	{ Name: '(GMT -10:00) ' + Lang.TimeHawaii, Value: '3' },
	{ Name: '(GMT -09:00) ' + Lang.TimeAlaska, Value: '4' },
	{ Name: '(GMT -08:00) ' + Lang.TimePacific, Value: '5' },
	{ Name: '(GMT -07:00) ' + Lang.TimeArizona, Value: '6' },
	{ Name: '(GMT -07:00) ' + Lang.TimeMountain, Value: '7' },
	{ Name: '(GMT -06:00) ' + Lang.TimeCentralAmerica, Value: '8' },
	{ Name: '(GMT -06:00) ' + Lang.TimeCentral, Value: '9' },
	{ Name: '(GMT -06:00) ' + Lang.TimeMexicoCity, Value: '10' },
	{ Name: '(GMT -06:00) ' + Lang.TimeSaskatchewan, Value: '11' },
	{ Name: '(GMT -05:00) ' + Lang.TimeIndiana, Value: '12' },
	{ Name: '(GMT -05:00) ' + Lang.TimeEastern, Value: '13' },
	{ Name: '(GMT -05:00) ' + Lang.TimeBogota, Value: '14' },
	{ Name: '(GMT -04:00) ' + Lang.TimeSantiago, Value: '15' },
	{ Name: '(GMT -04:00) ' + Lang.TimeCaracas, Value: '16' },
	{ Name: '(GMT -04:00) ' + Lang.TimeAtlanticCanada, Value: '17' },
	{ Name: '(GMT -03:30) ' + Lang.TimeNewfoundland, Value: '18' },
	{ Name: '(GMT -03:00) ' + Lang.TimeGreenland, Value: '19' },
	{ Name: '(GMT -03:00) ' + Lang.TimeBuenosAires, Value: '20' },
	{ Name: '(GMT -03:00) ' + Lang.TimeBrasilia, Value: '21' },
	{ Name: '(GMT -02:00) ' + Lang.TimeMidAtlantic, Value: '22' },
	{ Name: '(GMT -01:00) ' + Lang.TimeCapeVerde, Value: '23' },
	{ Name: '(GMT -01:00) ' + Lang.TimeAzores, Value: '24' },
	{ Name: '(GMT) ' + Lang.TimeMonrovia, Value: '25' },
	{ Name: '(GMT) ' + Lang.TimeGMT, Value: '26' },
	{ Name: '(GMT +01:00) ' + Lang.TimeBerlin, Value: '27' },
	{ Name: '(GMT +01:00) ' + Lang.TimePrague, Value: '28' },
	{ Name: '(GMT +01:00) ' + Lang.TimeParis, Value: '29' },
	{ Name: '(GMT +01:00) ' + Lang.TimeSarajevo, Value: '30' },
	{ Name: '(GMT +01:00) ' + Lang.TimeWestCentralAfrica, Value: '31' },
	{ Name: '(GMT +02:00) ' + Lang.TimeAthens, Value: '32' },
	{ Name: '(GMT +02:00) ' + Lang.TimeEasternEurope, Value: '33' },
	{ Name: '(GMT +02:00) ' + Lang.TimeCairo, Value: '34' },
	{ Name: '(GMT +02:00) ' + Lang.TimeHarare, Value: '35' },
	{ Name: '(GMT +02:00) ' + Lang.TimeHelsinki, Value: '36' },
	{ Name: '(GMT +02:00) ' + Lang.TimeIsrael, Value: '37' },
	{ Name: '(GMT +03:00) ' + Lang.TimeBaghdad, Value: '38' },
	{ Name: '(GMT +03:00) ' + Lang.TimeArab, Value: '39' },
	{ Name: '(GMT +03:00) ' + Lang.TimeMoscow, Value: '40' },
	{ Name: '(GMT +03:00) ' + Lang.TimeEastAfrica, Value: '41' },
	{ Name: '(GMT +03:30) ' + Lang.TimeTehran, Value: '42' },
	{ Name: '(GMT +04:00) ' + Lang.TimeAbuDhabi, Value: '43' },
	{ Name: '(GMT +04:00) ' + Lang.TimeCaucasus, Value: '44' },
	{ Name: '(GMT +04:30) ' + Lang.TimeKabul, Value: '45' },
	{ Name: '(GMT +05:00) ' + Lang.TimeEkaterinburg, Value: '46' },
	{ Name: '(GMT +05:00) ' + Lang.TimeIslamabad, Value: '47' },
	{ Name: '(GMT +05:30) ' + Lang.TimeBombay, Value: '48' },
	{ Name: '(GMT +05:45) ' + Lang.TimeNepal, Value: '49' },
	{ Name: '(GMT +06:00) ' + Lang.TimeAlmaty, Value: '50' },
	{ Name: '(GMT +06:00) ' + Lang.TimeDhaka, Value: '51' },
	{ Name: '(GMT +06:00) ' + Lang.TimeSriLanka, Value: '52' },
	{ Name: '(GMT +06:30) ' + Lang.TimeRangoon, Value: '53' },
	{ Name: '(GMT +07:00) ' + Lang.TimeBangkok, Value: '54' },
	{ Name: '(GMT +07:00) ' + Lang.TimeKrasnoyarsk, Value: '55' },
	{ Name: '(GMT +08:00) ' + Lang.TimeBeijing, Value: '56' },
	{ Name: '(GMT +08:00) ' + Lang.TimeIrkutsk, Value: '57' },
	{ Name: '(GMT +08:00) ' + Lang.TimeSingapore, Value: '58' },
	{ Name: '(GMT +08:00) ' + Lang.TimePerth, Value: '59' },
	{ Name: '(GMT +08:00) ' + Lang.TimeTaipei, Value: '60' },
	{ Name: '(GMT +09:00) ' + Lang.TimeTokyo, Value: '61' },
	{ Name: '(GMT +09:00) ' + Lang.TimeSeoul, Value: '62' },
	{ Name: '(GMT +09:00) ' + Lang.TimeYakutsk, Value: '63' },
	{ Name: '(GMT +09:30) ' + Lang.TimeAdelaide, Value: '64' },
	{ Name: '(GMT +09:30) ' + Lang.TimeDarwin, Value: '65' },
	{ Name: '(GMT +10:00) ' + Lang.TimeBrisbane, Value: '66' },
	{ Name: '(GMT +10:00) ' + Lang.TimeSydney, Value: '67' },
	{ Name: '(GMT +10:00) ' + Lang.TimeGuam, Value: '68' },
	{ Name: '(GMT +10:00) ' + Lang.TimeHobart, Value: '69' },
	{ Name: '(GMT +10:00) ' + Lang.TimeVladivostock, Value: '70' },
	{ Name: '(GMT +11:00) ' + Lang.TimeMagadan, Value: '71' },
	{ Name: '(GMT +12:00) ' + Lang.TimeWellington, Value: '72' },
	{ Name: '(GMT +12:00) ' + Lang.TimeFiji, Value: '73' },
	{ Name: '(GMT +13:00) ' + Lang.TimeTonga, Value: '74' }
];

var DateFormats = [
	{ Name: Lang.DateDefault,  Value: 'Default',  Id: 'date_format_0', LangField: 'DateDefault' },
	{ Name: Lang.DateDDMMYY,   Value: 'DD/MM/YY', Id: 'date_format_1', LangField: 'DateDDMMYY' },
	{ Name: Lang.DateMMDDYY,   Value: 'MM/DD/YY', Id: 'date_format_2', LangField: 'DateMMDDYY' },
	{ Name: Lang.DateDDMonth,  Value: 'DD Month', Id: 'date_format_3', LangField: 'DateDDMonth' },
	{ Name: Lang.DateAdvanced, Value: 'Advanced', Id: 'date_format_4', LangField: 'DateAdvanced' }
];
